.pos 0x100
    #stub
start:
    ld $stacktop, r5    # initialise stack pointer
    ld $tree, r0        # r0 = address of tree
    ld 0(r0), r0        # r0 = tree
    deca r5
    st r0, 0(r5)        # push tree
    gpc $6, r6
    j traverse          # call traverse
    inca r5             # discard pushed parameter
    halt

# void nodefunc(int t, struct bt_node *n)
# stack layout
# r5+4    n
# r5+0    t
nodefunc:
    ld 0(r5), r0        # r0 = t
    beq r0, t_eq_0      # goto t_eq_0 if t==0
    dec r0              # r0 = t - 1
    beq r0, t_eq_1      # goto t_eq_1 if t - 1 ==0 
    # else clause
    ld $nums_post, r0   # r0 = address of nums_post
    br t_if_done
t_eq_0:
    ld $nums_pre, r0    # r0 = address of nums_pre
    br t_if_done
t_eq_1:
    ld $nums_in, r0     # r0 = address of nums_in
t_if_done:
    ld $idx, r1         # r1 = address of idx
    ld 0(r1), r1        # r1 = idx
    ld 4(r5), r2        # r2 = n
    ld 0(r2), r2        # r2 = n->data
    ld (r0,r1,4), r3    # r3 = nums_pre[idx] or nums_in[idx] or nums_post[idx] (depending on choice)
    add r2, r3          # r3 = ... + n->data
    st r3, (r0,r1,4)    # store sum back into array
    ld $idx, r0         # r0 = address of idx
    inc r1              # r1 = idx + 1
    st r1, 0(r0)        # idx = idx + 1 i.e. idx++
    j 0(r6)             # return

# void traverse_pre(struct bt_node *n)
# stack layout
# r5+4    n
# r5+0    r6 (saved return address)
traverse_pre:
    deca r5
    st r6, 0(r5)        # save return address
    ld 4(r5), r0        # r0 = n
    beq r0, tpre_false  # goto tpre_false if n == 0
    deca r5
    st r0, 0(r5)        # push n
    ld $0, r0
    deca r5
    st r0, 0(r5)        # push 0
    gpc $6, r6
    j nodefunc          # call nodefunc
    inca r5
    inca r5             # discard pushed parameters
    ld 4(r5), r0        # r0 = n
    ld 4(r0), r0        # r0 = n->left
    deca r5
    st r0, 0(r5)        # push n->left
    gpc $6, r6
    j traverse_pre      # call traverse_pre
    # we can reuse the parameter slot without pop+push
    ld 8(r5), r0        # r0 = n (notice offset changed due to pushed parameter)
    ld 8(r0), r0        # r0 = n->right
    st r0, 0(r5)        # write into parameter
    gpc $6, r6
    j traverse_pre      # call traverse_pre
    inca r5             # discard pushed parameter
tpre_false:
    ld 0(r5), r6
    inca r5             # restore return address
    j 0(r6)             # return

# void traverse_in(struct bt_node *n)
# stack layout
# r5+4    n
# r5+0    r6 (saved return address)
traverse_in:
    deca r5
    st r6, 0(r5)        # save return address
    ld 4(r5), r0        # r0 = n
    beq r0, tin_false   # goto tin_false if n == 0
    ld 4(r0), r0        # r0 = n->left
    deca r5
    st r0, 0(r5)        # push n->left
    gpc $6, r6
    j traverse_in       # call traverse_in
    inca r5             # discard pushed parameter
    ld 4(r5), r0        # r0 = n
    deca r5
    st r0, 0(r5)        # push n
    ld $1, r0
    deca r5
    st r0, 0(r5)        # push 1
    gpc $6, r6
    j nodefunc          # call nodefunc
    inca r5
    inca r5             # discard pushed parameters
    ld 4(r5), r0        # r0 = n
    ld 8(r0), r0        # r0 = n->right
    deca r5
    st r0, 0(r5)        # push n->left
    gpc $6, r6
    j traverse_in       # call traverse_in
    inca r5             # discard pushed parameter
tin_false:
    ld 0(r5), r6
    inca r5             # restore return address
    j 0(r6)             # return

# void traverse_post(struct bt_node *n)
# stack layout
# r5+4    n
# r5+0    r6 (saved return address)
traverse_post:
    deca r5
    st r6, 0(r5)        # save return address
    ld 4(r5), r0        # r0 = n
    beq r0, tpost_false # goto tpost_false if n == 0
    ld 4(r0), r0        # r0 = n->left
    deca r5
    st r0, 0(r5)        # push n->left
    gpc $6, r6
    j traverse_post     # call traverse_post
    # we can reuse the parameter slot without pop+push
    ld 8(r5), r0        # r0 = n (notice offset changed due to pushed parameter)
    ld 8(r0), r0        # r0 = n->right
    st r0, 0(r5)        # write into parameter
    gpc $6, r6
    j traverse_post     # call traverse_post
    inca r5             # discard pushed parameter
    ld 4(r5), r0        # r0 = n
    deca r5
    st r0, 0(r5)        # push n
    ld $2, r0           # r0 = 2
    deca r5
    st r0, 0(r5)        # push 2
    gpc $6, r6
    j nodefunc          # call nodefunc
    inca r5
    inca r5             # discard pushed parameters
tpost_false:
    ld 0(r5), r6
    inca r5             # restore return address
    j 0(r6)             # return

# void traverse(struct bt_node *n)
# stack layout
# r5+4    n
# r5+0    r6 (saved return address)
traverse:
    deca r5
    st r6, 0(r5)        # save return address
    ld 4(r5), r0        # r0 = n
    deca r5
    st r0, 0(r5)        # push n
    gpc $6, r6
    j traverse_pre      # call traverse_pre
    ld $idx, r0         # r0 = address of idx
    ld $0, r1           # r1 = 0
    st r1, 0(r0)        # idx = 0
    # we can reuse the parameter slot without pop+push
    ld 8(r5), r0        # r0 = n
    st r0, 0(r5)        # write parameter n
    gpc $6, r6
    j traverse_in       # call traverse_in
    ld $idx, r0         # r0 = address of idx
    ld $0, r1           # r1 = 0
    st r1, 0(r0)        # idx = 0
    # we can reuse the parameter slot without pop+push
    ld 8(r5), r0        # r0 = n
    st r0, 0(r5)        # write parameter n
    gpc $6, r6
    j traverse_post     # call traverse_in
    inca r5             # discard pushed parameter
    ld 0(r5), r6
    inca r5             # restore return address
    j 0(r6)             # return

.pos 0x400
# Static data area
tree:
    .long 0x1000        # tree (pointer to tree structure)
idx:
    .long 0             # idx
nums_pre:
    .long 0             # nums_pre[0]
    .long 0             # nums_pre[1]
    .long 0             # nums_pre[2]
    .long 0             # nums_pre[3]
    .long 0             # nums_pre[4]
    .long 0             # nums_pre[5]
    .long 0             # nums_pre[6]
    .long 0             # nums_pre[7]
    .long 0             # nums_pre[8]
    .long 0             # nums_pre[9]
    .long 0             # nums_pre[10]
    .long 0             # nums_pre[11]
nums_in:
    .long 0             # nums_in[0]
    .long 0             # nums_in[1]
    .long 0             # nums_in[2]
    .long 0             # nums_in[3]
    .long 0             # nums_in[4]
    .long 0             # nums_in[5]
    .long 0             # nums_in[6]
    .long 0             # nums_in[7]
    .long 0             # nums_in[8]
    .long 0             # nums_in[9]
    .long 0             # nums_in[10]
    .long 0             # nums_in[11]
nums_post:
    .long 0             # nums_post[0]
    .long 0             # nums_post[1]
    .long 0             # nums_post[2]
    .long 0             # nums_post[3]
    .long 0             # nums_post[4]
    .long 0             # nums_post[5]
    .long 0             # nums_post[6]
    .long 0             # nums_post[7]
    .long 0             # nums_post[8]
    .long 0             # nums_post[9]
    .long 0             # nums_post[10]
    .long 0             # nums_post[11]

.pos 0x1000
# Area for tree structure.
    .long 5             # data
    .long 0x100c        # left
    .long 0x1048        # right
    .long 3             # data
    .long 0x1018        # left
    .long 0x103c        # right
    .long 18            # data
    .long 0x1024        # left
    .long 0x1030        # right
    .long 9             # data
    .long 0             # left
    .long 0             # right
    .long 11            # data
    .long 0             # left
    .long 0             # right
    .long 7             # data
    .long 0             # left
    .long 0             # right
    .long 1             # data
    .long 0x1054        # left
    .long 0x106c        # right
    .long 4             # data
    .long 0x1060        # left
    .long 0             # right
    .long 2             # data
    .long 0             # left
    .long 0             # right
    .long 6             # data
    .long 0x1078        # left
    .long 0x1084        # right
    .long 0             # data
    .long 0             # left
    .long 0             # right
    .long 8             # data
    .long 0             # left
    .long 0             # right

.pos 0x7FC0
# These are here so you can see (some of) the stack contents.
    .long 0
    .long 0
    .long 0
    .long 0
    .long 0
    .long 0
    .long 0
    .long 0
    .long 0
    .long 0
    .long 0
    .long 0
    .long 0
    .long 0
    .long 0
    .long 0
# Stack top (one word past end of stack)
stacktop:
    .long 0
